var YBApp = {
	URL: {
		HOST: 'http://m.17yuebei.com',
		APP_ACCESS: '/services/user/access',
		USER_VIEW_HISTORY: '/services/user/viewHistory',
		USER_FAVORITE: '/services/user/favorite',
		USER_MESSAGES: '/services/user/message',
		USER_GETADDRESS: '/services/user/getAddress',
		USER_ALLADDRESS: '/services/user/allAddress',
		USER_ADD_ADDRESS: '/services/user/addAddress',
		USER_UPDATE_ADDRESS: '/services/user/updateAddress',
		USER_DELETE_ADDRESS: '/services/user/deleteAddress',
		USER_SET_DEFAULT_ADDRESS: '/services/user/defautAddress',
		USER_GET_COUPON_COUNT: '/services/user/getCouponCount',
		USER_GET_COUPON: '/services/user/getCoupon',
		USER_GOODS_ARRIVAL_NOTICE: '/services/user/arrivalNotice',
		USER_GET_MONEY: '/services/user/getMoney',
		USER_GET_MONEY_TRADELOGS: '/services/user/getMoneyTradeLogs',
		USER_GET_USERACCOUNT: '/services/user/getUserAccount',
		USER_GET_CHILDINFO: '/services/user/getChildInfo',
		USER_UPDATE_CHILDINFO: '/services/user/updateChildInfo',
		USER_UPDATE_USERINFO: '/services/user/updateUserInfo',
		USER_UPDATE_USERICON: '/services/user/updateIcon',
		USER_GET_BINDPHONE: '/services/user/bindPhone',
		BOOK_COMMENT: '/services/book/comment',
		BOOK_SEARCH: '/services/book/search',
		BOOK_MYITEM: '/services/book/myItem',
		BOOK_MYSHORTITEM: '/services/book/myShortItem',
		BOOK_FAVORITE: '/services/book/favorite',
		BOOK_COMMENT_LIKE: '/services/book/commentLike',
		CART_BUY_GOODS: '/services/cart/buyGoods',
		CART_BORROW_BOOK: '/services/cart/borrowBook',
		CART_NUM: '/services/cart/cartNum',
		CART_DETAIL: '/services/cart/cartDetail',
		CART_DELETE: '/services/cart/delete',
		CART_UPDATE_NUM: '/services/cart/updateGoodsNum',
		CART_UPDATE_SELECT: '/services/cart/updateGoodsSelect',
		CART_UPDATE_ALL_SELECT: '/services/cart/updateAllGoodsSelect',
		CART_UPDATE_BORROWDAYS: '/services/cart/updateBorrowDays',
		ORDER_CREATE_PREORDER: '/services/order/createPreOrder',
		ORDER_GET_PREORDER: '/services/order/getPreOrder',
		ORDER_UPDATE_ADDRESS: '/services/order/updateAddress',
		ORDER_UPDATE_COURIER: '/services/order/updateCourier',
		ORDER_UPDATE_COUPONCOST: '/services/order/updateCouponCost',
		ORDER_UPDATE_BEIBICOST: '/services/order/updateBeiBiCost',
		ORDER_CREATE: '/services/order/createOrder',
		ORDER_GET_UNPAID_ORDER: '/services/order/getUnPaidOrderPayment',
		ORDER_GET_PAID_ORDER: '/services/order/getPaidOrderPayment',
		ORDER_GET_MY_ORDER: '/services/order/getMyAllOrder',
		ORDER_GET_MY_BORROW_ORDER: '/services/order/getMyAllBorrowOrder',
		ORDER_GET_MY_UNPAID_ORDER: '/services/order/getMyAllUnPaidOrder',
		ORDER_GET_MY_ORDER_DETAIL: '/services/order/getOrderDetail',
		ORDER_GET_MY_ORDER_DELIVER_LAST_INFO: '/services/order/getOrderLastDeliverInfo',
		ORDER_GET_MY_LENDORDER_DELIVER_LAST_INFO: '/services/order/getLendOrderLastDeliverInfo',
		ORDER_GET_MY_ORDER_DELIVER_INFO: '/services/order/getOrderDeliverInfo',
		ORDER_COMMINT_BACK_BOOK: '/services/order/commitReturnBook',
		ORDER_CONFIRM_STATMENT: '/services/order/confirmStatement',
		ORDER_GET_DAMAGE_LOGS: '/services/order/getDamageLogs',
		WX_GET_BRANDPAYJSON: '/services/weixin/getBrandPayJson',
		WX_GET_WEBCONFIG: '/services/weixin/getWebConfigJson',
		WX_GET_OPENID: '/services/weixin/getOpenId',
		ALIPAY_GET_PAYREQCONFORAPP: '/services/alipay/getPayRequestContentForApp',
	},
	data: {
		sid: "",
		userName: "",
		vUid: "",
		curUrl: "",
		lastUrl: ""
	},
	connecting: false,
	Str: {
		NETWORK_BUSY: "网络繁忙，请稍后再试",
		NETWORK_ERROR: "网络连接出错，请检查网络是否正常",
	}
};

(function($, window) {
	$.URL.HOST = 'http://' + window.location.host;
	$.data.sid = getCookie('sid');
	$.data.vUid = getVUid();
	$.data.curUrl = window.location.href;

	var curUrl = decodeURIComponent(getCookie('curUrl'));

	if(isNotBlank(curUrl) && curUrl != $.data.curUrl) {
		setCookie('lastUrl', curUrl, 1);
	}
	$.data.lastUrl = decodeURIComponent(getCookie('lastUrl'));

	setCookie('curUrl', $.data.curUrl, 1);
})(YBApp, window);

(function($, window) {
	$.loadingToast = {
		show: function() {
			var body = document.body;
			var div = document.createElement('div');
			div.className = 'weui_loading_toast';
			div.id = 'loadingToast';

			var innerStr = '<!--<div class="weui_mask_transparent"></div>--><div class="weui_toast">';
			innerStr += '<div class="weui_loading">';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_0"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_1"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_2"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_3"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_4"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_5"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_6"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_7"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_8"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_9"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_10"></div>';
			innerStr += '<div class="weui_loading_leaf weui_loading_leaf_11"></div>';
			innerStr += '</div><!--<p class="weui_toast_content">正在操作中</p>--></div>';
			div.innerHTML = innerStr;
			body.appendChild(div);
		},
		close: function() {
			var node = getEle('loadingToast');
			if(isNotBlank(node)) {
				node.remove();
			};
		}
	};
	$.toast = function(isSuccess, message, time) {
		var t = 2000;
		if(isNotBlank(time)){
			t = time;
		}
		var body = document.body;
		var div = document.createElement('div');
		div.className = 'message-floor';
		var innerStr = '<div class="messge-box">';
		innerStr += '<div class="messge-box-icon">';
		if(isSuccess) {
			innerStr += '<i class="bottom-focus-icon succee-icon"></i>';
		} else {
			innerStr += '<i class="bottom-focus-icon error-icon"></i>';
		}
		innerStr += '</div><div class="messge-box-content">' + message + '</div></div>';
		div.innerHTML = innerStr;
		body.appendChild(div);
		setTimeout(function() {
			div.remove();
		}, t);
	};
	//用这确认框解决mui确认框不是浮动会显示在屏幕外问题
	$.confirm = {

		show: function(message, callback, btn) {
			var body = document.body;
			var div = document.createElement('div');
			div.className = 'weui_dialog_confirm';
			div.id = 'confirmDialog';
			var leftBtn = '取消';
			var rightBtn = '确定';
			if(isNotBlank(btn)) {
				leftBtn = btn[0];
				rightBtn = btn[1];
			}
			var innerStr = '<div class="weui_mask"></div>';
			innerStr += '<div class="weui_dialog">';
			innerStr += '<div class="weui_dialog_hd"><strong class="weui_dialog_title">提示</strong></div>';
			innerStr += '<div class="weui_dialog_bd">' + message + '</div>';
			innerStr += '<div class="weui_dialog_ft">';
			innerStr += '<a href="javascript:;" id="confirmDialogChannel" class="weui_btn_dialog default">' + leftBtn + '</a>';
			innerStr += '<a href="javascript:;" id="confirmDialogOK" class="weui_btn_dialog primary">' + rightBtn + '</a>';
			innerStr += '</div></div>';
			div.innerHTML = innerStr;
			this.elm = div;
			//			var first = document.body.firstChild; //得到页面的第一个元素 
			//			document.body.insertBefore(div, first); //在得到的第一个元素之前插入

			body.appendChild(div);
			this.bind(callback);
		},
		close: function() {
			//this.elm.classList.add('mui-hidden');
			this.elm.remove();
		},
		bind: function(callback) {
			var elm = this;
			mui('#confirmDialog').on('tap', '.weui_btn_dialog', function() {
				elm.close();
				if(this.classList.contains('default')) {
					callback({
						index: 0
					});
				} else {
					callback({
						index: 1
					});
				}
			});
		}
	};
	$.alert = {
		show: function(message, title, btn) {
			var body = document.body;
			var div = document.createElement('div');
			div.className = 'weui_dialog_confirm';
			div.id = 'alertDialog';
			var alertBtn = '确定';
			var alertTitle = "提示";
			if(isNotBlank(btn)) {
				alertBtn = btn;
			}
			if(isNotBlank(title)) {
				alertTitle = title;
			}
			var innerStr = '<div class="weui_mask"></div>';
			innerStr += '<div class="weui_dialog">';
			innerStr += '<div class="weui_dialog_hd"><strong class="weui_dialog_title">' + alertTitle + '</strong></div>';
			innerStr += '<div class="weui_dialog_bd">' + message + '</div>';
			innerStr += '<div class="weui_dialog_ft">';
			innerStr += '<a href="javascript:;" id="confirmDialogOK" class="weui_btn_dialog primary">' + alertBtn + '</a>';
			innerStr += '</div></div>';
			div.innerHTML = innerStr;
			this.elm = div;
			body.appendChild(div);
			this.bind();
		},
		close: function() {
			this.elm.remove();
		},
		bind: function() {
			var elm = this;
			mui('#alertDialog').on('tap', '.weui_btn_dialog', function() {
				elm.close();
			});
		}
	};
	$.freeAlert = {
		show: function(innerHtml) {
			var body = document.body;
			var div = document.createElement('div');
			div.id = 'freeAlertDialog';
			var innerStr = '<div class="weui_mask"></div>';
			innerStr += '<div class="free_dialog">';
			innerStr += innerHtml;
			innerStr += '</div>';
			div.innerHTML = innerStr;
			this.elm = div;
			body.appendChild(div);
			this.bind();
		},
		close: function() {
			this.elm.remove();
		},
		bind: function() {
			var elm = this;
			mui('#freeAlertDialog').on('tap', '.freeAlertClose', function() {
				elm.close();
			});
		}
	};
	$.prompt = {
		show: function(message, inputtype, callback) {
			var body = document.body;
			var div = document.createElement('div');
			div.className = 'weui_dialog_confirm';
			div.id = 'promptDialog';
			var innerStr = '<div class="weui_mask"></div>';
			innerStr += '<div class="weui_dialog">';
			innerStr += '<div class="weui_dialog_hd"><strong class="weui_dialog_title">提示</strong></div>';
			innerStr += '<div class="weui_dialog_bd">' + message + '</div>';
			innerStr += '<div style="margin-left:15px;margin-right:15px;" ><input type="' + inputtype + '" id="promptInput" autofocus="on"/></div>';
			innerStr += '<div class="weui_dialog_ft">';
			innerStr += '<a href="javascript:;" id="promptDialogChannel" class="weui_btn_dialog default">取消</a>';
			innerStr += '<a href="javascript:;" id="promptDialogOK" class="weui_btn_dialog primary">确定</a>';
			innerStr += '</div></div>';
			div.innerHTML = innerStr;
			this.elm = div;
			//			var first = document.body.firstChild; //得到页面的第一个元素 
			//			document.body.insertBefore(div, first); //在得到的第一个元素之前插入

			body.appendChild(div);
			this.bind(callback);
			getEle('promptInput').focus();
		},
		close: function() {
			//this.elm.classList.add('mui-hidden');
			this.elm.remove();
		},
		bind: function(callback) {
			var elm = this;
			mui('#promptDialog').on('tap', '.weui_btn_dialog', function() {
				var v = getEle('promptInput').value;
				if(this.classList.contains('default')) {
					callback({
						index: 0,
						value: v
					});
				} else {
					callback({
						index: 1,
						value: v
					});
				}
				elm.close();
			});
		}
	};
	window.addEventListener('tap', function(e) {
		var action = mui.targets.action;
		if(action && action.classList.contains('mui-action-index')) {
			YBApp.openWindow('/index.html');
		}
	});
	//	$.back = function() {//XXX  用这个在返回有下拉列表的界面时会重新开始
	//		mui.openWindow($.data.lastUrl);
	//	};
	//打包成ios　APP如果不加http://域名，会报找不一到样面的错，而且不加随机数会缓存页面
	$.openWindow = function(url) {
		if(mui.os.plus) {
			if(url.indexOf('http://') < 0) {
				if(url.indexOf('/') == 0) {
					url = $.URL.HOST + url
				} else {
					url = $.URL.HOST + "/" + url
						//					var lastIndex = $.data.curUrl.lastIndexOf('/');
						//					var path = $.data.curUrl.substring(0,lastIndex);
						//					url = path + url
				}
			}
			if(url.indexOf('?') > 0) {
				url = url + '&r=' + randomString(6);
			} else {
				url = url + '?r=' + randomString(6);
			}
		}
		mui.openWindow(url);
	}

})(YBApp, window);

mui.ready(function() {
	mui(".mui-content").on('tap', 'a', function() {
		var href = this.getAttribute("href");
		if(isNotBlank(href) && href.indexOf("#") != 0) {
			YBApp.openWindow(href);
		}
	});
	mui(".mui-page").on('tap', 'a', function() {
		var href = this.getAttribute("href");
		if(isNotBlank(href) && href.indexOf("#") != 0) {
			YBApp.openWindow(href);
		}
	});
	var reqStr = {
		href: encodeURIComponent(YBApp.data.curUrl),
		vUid: YBApp.data.vUid
	};
	ybAjaxGet(YBApp.URL.APP_ACCESS, reqStr, function() {});
});

function getQueryString(str) {
	var rs = new RegExp("(^|)" + str + "=([^&]*)(&|$)", "gi").exec(YBApp.data.curUrl),
		tmp;
	if(tmp = rs) return tmp[2];
	return "";
}

function isLogin() {
	return isNotBlank(YBApp.data.sid);
}

function getVUid() {
	var vUid = getCookie('vUid');
	if(!isNotBlank(vUid)) {
		vUid = genBillNo();
		setCookie('vUid', vUid, 1);
	}
	return vUid;
};
//ajax请求 mui get 参数
function ybAjaxGet(sURL, reqStr, onSuccess, showLoading, onError) {
	mui.ajax({
		type: "GET",
		url: sURL,
		contentType: "application/json; charset=utf-8",
		dataType: 'json',
		beforeSend: function(request) {
			if(showLoading) {
				YBApp.loadingToast.show();
			}
			YBApp.connecting = true;
		},
		cache: false,
		data: reqStr,
		timeout: 10000,
		headers: {
			"sid": YBApp.data.sid,
			"vUid": YBApp.data.vUid
		},
		success: onSuccess,
		error: function(xhr, type, error) {
			ajaxError(xhr, type, error);
			if(mui.isFunction(onError)) {
				onError.call(xhr, type, error);
			}
		},
		complete: ajaxComplete
	});
};
//ajax请求mui  post json
function ybAjaxPost(sURL, reqStr, onSuccess, showLoading, onError) {
	mui.ajax(sURL, {
		type: "POST",
		contentType: "application/json; charset=utf-8",
		dataType: 'json',
		cache: false,
		beforeSend: function(request) {
			if(showLoading) {
				YBApp.loadingToast.show();
			}
			YBApp.connecting = true;
		},
		data: reqStr,
		timeout: 10000,
		headers: {
			"sid": YBApp.data.sid,
			"vUid": YBApp.data.vUid
		},
		success: onSuccess,
		error: function(xhr, type, error) {
			ajaxError(xhr, type, error);
			if(mui.isFunction(onError)) {
				onError.call(xhr, type, error);
			}
		},
		complete: ajaxComplete
	});
}

function ajaxError(xhr, type, error) {
	mui.toast(YBApp.Str.NETWORK_ERROR);
}

function ajaxComplete(xhr, status) {
	YBApp.connecting = false;
	YBApp.loadingToast.close();
	//	console.log('ajax complete status=' + status);
}