//mui初始化
mui.init({
	statusBarBackground: '#f7f7f7',
	swipeBack: true //启用右滑关闭功能
});
if(mui.os.wechat) {
	document.write("<script src='js/jweixin-1.0.0.js'><\/script>");
}
(function() {
	mui(document).imageLazyload({
		placeholder: 'icon/imgloading.png'
	});
	new Swiper(".index_ads", {
			pagination: ".swiper-pagination",
			paginationClickable: true,
			centeredSlides: true,
			autoplay: 2500,
			autoplayDisableOnInteraction: false,
			loop: true,
			preloadImages: false,
			lazyLoading: true
		}),
		new Swiper(".related-item-list", {
			slidesOffsetBefore: 10,
			slidesPerView: 3.5,
			paginationClickable: true,
			freeMode: true,
			//			slidesPerColumn: 2,
			lazyLoading: true
		});
	var broadcastSwiper = new Swiper(".broadcast_title", {
		paginationClickable: true,
		centeredSlides: true,
		noSwiping: true,
		autoplay: 3500,
		autoplayDisableOnInteraction: false,
		loop: true,
		direction: "vertical"
	});

	var tablist = ['index', 'category', 'baobao', 'wo'];
	var curtab = getSessionStorage('curTab');
	var showtab = getSessionStorage("showtab");
	if(showtab != null) {
		curtab = showtab;
		setSessionStorage('curTab', curtab);
		removeSessionStorage("showtab");
	}
	mui.each(tablist, function(idx, obj) {
		document.getElementById(obj + "-tab").addEventListener('tap', function() {
			setSessionStorage('curTab', obj);
			curtab = obj;
			if(!isContains(curtab, 'index')) {
				$(".to-top").remove();
			}
			//切换TAB时获取下购物车物品
			getCartDetail();
		});
		if(curtab != null) {
			removeClass(obj + "-tab", 'mui-active');
			removeClass("tabbar-with-" + obj, 'mui-active');
		}
	});
	if(curtab != null) {
		addClass(curtab + "-tab", 'mui-active');
		addClass("tabbar-with-" + curtab, 'mui-active');
	};
	$(window).on("scroll", function() {
		var scrollTop = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop;
		if(curtab == null || isContains(curtab, 'index')) {
			scrollTop > 100 ? 0 == $(".to-top").length && ($("body").append('<div class="to-top"><a href="javascript:void(0);" id="to-top"><i class="top-icon dav_icon_up2top_80_80" style="width:44px;height:44px;"></i></a></div>'), $("#to-top").on("tap", function() {
				mui.scrollTo(0, 100, null);
			})) : $(".to-top").remove();
		}
	});
	var isLoaded = false;
	$(window).on("scroll", function() {
		var scrollTop = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop;
		var bodyH = $("body").height();
		var windowH = $(window).height();
		var bottomH = (bodyH - scrollTop - windowH);
		if(bottomH < 100 && !isLoaded) {
			ybAjaxGet("/services/book/getRecommend", null, function(jsonObj) {
				hideEle('rec-loading');
				if(jsonObj.success) {
					var recHtml = htmlRecommend(jsonObj.data);
					setEleHtml('recDiv', recHtml);
					mui(document).imageLazyload({
						placeholder: 'icon/imgloading.png'
					});
				}
			}, false);
			isLoaded = true;
		}
		if(scrollTop > 100) {
			$("#index-search").fadeOut(1000);
			$("#beibaoHeader").fadeOut(500);
		} else {
			$("#index-search").fadeIn(1000);
			$("#beibaoHeader").fadeIn(500);
		}
	});
	//	document.addEventListener('touchmove', function(event) {
	//		var scrollTop = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop;
	//	}, false);
	if(mui.os.wechat) {

	}
	if(mui.os.plus) {
		document.addEventListener('plusready', function() {
			plus.statistic.eventTrig("index", "pv");
		}, false);
	}
	if(mui.os.android) {

	}
	if(mui.os.ios) {

	}
	getEle('babao_confirm_btn').addEventListener('tap', function() {
		if(this.classList.contains('btn-disable')) {
			return;
		}
		ybAjaxGet(YBApp.URL.ORDER_CREATE_PREORDER, null, function(jsonObj) {
			if(!isNotBlank(jsonObj)) {
				mui.toast(YBApp.Str.NETWORK_BUSY);
			} else if(jsonObj.success) {
				YBApp.openWindow('/order/index.html');
			} else {
				if(jsonObj.code == 301) {
					YBApp.openWindow('/login.html');
				} else {
					YBApp.toast(false, jsonObj.msg);
				}
			}
		});
	});

	//进入主页获取下购物车物品
	getCartDetail();
	//修改数量
	mui('#tabbar-with-baobao').on('change', 'input', function() {
		if(this.id.indexOf('borrowDaysBtn') > -1) {
			var ele = this;
			var reqStr = {
				borrowDays: this.value,
			};
			ybAjaxGet(YBApp.URL.CART_UPDATE_BORROWDAYS, reqStr, function(jsonObj) {
				if(!isNotBlank(jsonObj)) {
					return;
				}
				if(jsonObj.success) {
					updateCartInfo(jsonObj);
				} else {
					mui.toast(jsonObj.msg);
				}
			}, true, function() {
				ele.value = ele.getAttribute('data-last-value');
			});
			return;
		}
		if(this.type.indexOf('number') > -1) {
			var ele = this;
			var li = this.parentNode.parentNode.parentNode.parentNode.parentNode;
			var pid = li.getAttribute('data-pid');
			var isBorrow = li.getAttribute('data-isBorrow');
			var reqStr = {
				id: pid,
				num: this.value,
				isBorrow: isBorrow,
				vUid: YBApp.data.vUid,
			};
			ybAjaxGet(YBApp.URL.CART_UPDATE_NUM, reqStr, function(jsonObj) {
				if(!isNotBlank(jsonObj)) {
					return;
				}
				if(jsonObj.success) {
					updateCartInfo(jsonObj);
				} else {
					mui.toast(jsonObj.msg);
				}
			}, true, function() {
				ele.value = ele.getAttribute('data-last-value');
			});
		};
	});
	//选中
	mui('#cart-detail-area').on('tap', 'input', function() {
		var ele = this;
		var id = this.id;
		var type = this.type;
		if(isNotBlank(type) && type.indexOf('checkbox') < 0) {
			return;
		}
		var li = this.parentNode;
		var pid = li.getAttribute('data-pid');
		var isBorrow = li.getAttribute('data-isBorrow');
		var reqStr = {
			id: pid,
			isSelect: !this.checked,
			isBorrow: isBorrow,
			vUid: YBApp.data.vUid,
		};
		ybAjaxGet(YBApp.URL.CART_UPDATE_SELECT, reqStr, function(jsonObj) {
			if(!isNotBlank(jsonObj)) {
				return;
			}
			if(jsonObj.success) {
				updateCartInfo(jsonObj);
			} else {
				mui.toast(jsonObj.msg);
			}
		}, true);
	});
	//全选按钮
	getEle('checKall').addEventListener('click', function(event) {
		var ele = this;
		var reqStr = {
			isSelect: this.checked,
			vUid: YBApp.data.vUid,
		};
		ybAjaxGet(YBApp.URL.CART_UPDATE_ALL_SELECT, reqStr, function(jsonObj) {
			if(!isNotBlank(jsonObj)) {
				return;
			}
			if(jsonObj.success) {
				updateCartInfo(jsonObj);
			} else {
				mui.toast(jsonObj.msg);
			}
		}, true, function() {
			ele.checked = !ele.checked;
		});
	});
	//点击行
	mui("#tabbar-with-baobao").on('tap', 'li', function() {
		var pid = this.getAttribute('data-pid');
		var selected = this.parentNode.querySelector(".mui-selected");
		mui.swipeoutClose(selected);
	});
	//删除操作
	mui('#tabbar-with-baobao').on('tap', '.mui-btn', function(event) {
		if(isNotBlank(this.type) && this.type.indexOf('button') > -1) { //排除操作数量按钮
			return;
		}
		var elem = this;
		var li = elem.parentNode.parentNode;
		var pid = li.getAttribute('data-pid');
		var isBorrow = li.getAttribute('data-isBorrow');
		YBApp.confirm.show('确定要从贝包里删除吗？', function(e) {
			if(e.index == 1) {
				var reqStr = {
					id: pid,
					isBorrow: isBorrow,
					vUid: YBApp.data.vUid,
				};
				ybAjaxGet(YBApp.URL.CART_DELETE, reqStr, updateCartInfo, true);
			} else {
				setTimeout(function() {
					mui.swipeoutClose(li);
				}, 0);
			}
		});
	});
	mui("#tabbar-with-index").on('tap', '.df_new_title_2', function() {
		var href = this.getAttribute('data-href');
		if(isNotBlank(href)) {
			YBApp.openWindow(href);
		}
	});
	getEle('gotoLogin').addEventListener('tap', function(event) {
		YBApp.openWindow('login.html');
	});

	function getCartNum() {
		var reqStr = {
			vUid: YBApp.data.vUid,
		};
		ybAjaxGet(YBApp.URL.CART_NUM, reqStr, updateCartInfo);
	}

	function getCartDetail() {
		var reqStr = {
			vUid: YBApp.data.vUid,
		};
		ybAjaxGet(YBApp.URL.CART_DETAIL, reqStr, updateCartInfo);
	}

	function updateCartInfo(jsonObj) {
		if(!isNotBlank(jsonObj)) {
			return;
		}
		if(jsonObj.success) {
			removeClass('babao_confirm_btn', 'btn-disable');
			var r = jsonObj.data;
			if(isNotBlank(r)) {
				if(r.total > 0) {
					hideEle('cart-empty-show');
					showEle('cart-detail-area');
					showEle('tab-cart-totalnum');
					setEleText('tab-cart-totalnum', r.total);
					setEleText('cart-selectcount', r.selectCount)
					if(r.selectCount == 0) {
						addClass('babao_confirm_btn', 'btn-disable');
					}
					if(r.total > r.selectCount) {
						getEle('checKall').checked = false;
					} else {
						getEle('checKall').checked = true;
					}
					if(isNotBlank(r.totalPriceShow)) {
						setEleText('cart-totalprcie', r.totalPriceShow);
					}
					var htmlGoods = '';
					var borrowGoods = r.borrowList;
					if(isNotBlank(borrowGoods)) {
						if(borrowGoods.length > 0) {
							htmlGoods = htmlBorrowDetailHeader(r);
						}
						mui.each(borrowGoods, function(idx, obj) {
							htmlGoods += htmlBorrowGoods(obj);
						});
						if(borrowGoods.length > 0) {
							htmlGoods += htmlBorrowDetailFooter(r);
						}
					}
					var buyGoods = r.buyList;
					if(isNotBlank(buyGoods)) {
						if(isNotBlank(htmlGoods)) {
							htmlGoods += '<li class="mui-table-view-divider"></li>';
						}
						htmlGoods += htmlBuyDetailHeader(r);
						mui.each(buyGoods, function(idx, obj) {
							htmlGoods += htmlBuyGoods(obj);
						});
						htmlGoods += htmlBuyDetailFooter(r);
					}
					var cartArea = getEle('cart-detail-area');
					cartArea.innerHTML = htmlGoods;
					mui('.mui-numbox').numbox();
					if(isNotBlank(getEle('yajin-help'))) {
						getEle("yajin-help").addEventListener('tap', function() {
							YBApp.openWindow("/qa.html");
						});
					}
					return;
				} else {
					addClass('checKall', 'mui-disabled');
				}
			}
			hideEle('tab-cart-totalnum');
			setEleText('tab-cart-totalnum', 0);
			setEleText('cart-selectcount', 0)
			getEle('checKall').checked = false;
			setEleText('cart-totalprcie', "0.00");
			addClass('babao_confirm_btn', 'btn-disable');
		}
		showEle('cart-empty-show');
		hideEle('cart-detail-area');

	}

	function htmlRecommend(list) {
		var html = [];
		mui.each(list, function(idx, obj) {
			html.push('<a href="/item/' + obj.fileUrl + '" class="good_item">');
			html.push('<div class="good_img_container">');
			html.push('<img style="display: inline;" data-lazyload="/images/product/s300x300/' + obj.icon + '">');
			//		html.push('<div class="tag tag2"></div>');
			html.push('</div>');
			html.push('<div class="good_con">');
			html.push('<div class="good_title">' + obj.name + '</div>');
			//		html.push('<div class="fz_12">');
			//		html.push('<span class="dav-color-price"></span>');
			//		html.push('</div>');
			html.push('</div>');
			html.push('</a>');
		});
		return html.join('');
	}

	function htmlBorrowDetailHeader(obj) {
		var innerHtml = '<li class="mui-table-view-divider cell-divider">';
		//		innerHtml += '借阅的书<span style="font-size:12px;margin-left: 5px;">(<span class="yb-media-num1">' + obj.selectBorrowCount + '</span>本)&nbsp;&nbsp;&nbsp;第<span class="yb-media-num1">' + obj.borrowTimes + '</span>次借阅&nbsp;可借<span class="yb-media-num1">' + obj.allowBorrowCount + '</span>本&nbsp;还可选<span class="yb-media-num1">' + obj.remainBorrowCount + '</span>本</span>';
		innerHtml += '借阅的书<span style="font-size:12px;margin-left: 5px;">(<span class="yb-media-num1">' + obj.selectBorrowCount + '</span>本)</span><span class="yb-title-text-pormpt-small"><span id="yajin-help" class="mui-icon mui-icon-help" style="font-size: 17px;margin-left:10px;"></span>借阅常见问题</span>';
		innerHtml += '</li>';
		return innerHtml;
	}

	function htmlBorrowDetailFooter(obj) {
		var innerHtml = '<li class="mui-table-view-cell"><span class="yb-title-text-importmant">预付款&nbsp;&nbsp;<span class="yb-title-text-pormpt-small">(每天累计借阅费:<span class="price">¥';
		if(obj.vipBorrowDiscount > 0) {
			innerHtml += obj.discountTotalRentalS;
		} else {
			innerHtml += obj.borrowTotalRentalS;
		}
		innerHtml += '</span>)</span><span class="mui-pull-right price">¥' + obj.borrowTotalSalePriceS + '</span></span></li>';
		innerHtml += '<li class="mui-table-view-divider"><span class="yb-title-text-pormpt-small">书本归还结算后，剩余预付款将原路退还</span></li>';
		return innerHtml;
	}

	function htmlBuyDetailHeader(obj) {
		var innerHtml = '<li class="mui-table-view-divider cell-divider">';
		innerHtml += '购买的商品<span style="font-size:12px;margin-left: 5px;">(<span class="yb-media-num1">' + obj.selectBuyCount + '</span>件)</span>';
		innerHtml += '</li>';
		return innerHtml;
	}

	function htmlBuyDetailFooter(obj) {
		var innerHtml = '<li class="mui-table-view-cell"><span class="yb-title-text-importmant">购买小计<span class="mui-pull-right price">¥' + obj.buyTotalPriceS + '</span></span></li>';
		return innerHtml;

	}

	function htmlBorrowGoods(obj) {
		var innerHtml = '<li data-pid="' + obj.id + '" data-isBorrow="true" class="mui-table-view-cell mui-collapse mui-checkbox mui-left">';
		innerHtml += '<input name="checkbox" type="checkbox"  ' + (obj.selected ? "checked" : "") + '>';
		innerHtml += '<div class="mui-slider-right mui-disabled"><a class="mui-btn mui-btn-red">删除</a></div>';
		innerHtml += '<div class="mui-slider-handle">';
		innerHtml += '<a href="item/' + obj.url + '"><img class="yb-mui-media-object-middling mui-pull-left" src="images/product/s300x300/' + obj.icon + '">';
		innerHtml += '<div class="mui-media-body" style="color: #222222;height:90px"><span class="yb-title-text-importmant mui-ellipsis-2">';
		innerHtml += obj.name;
		innerHtml += '</span><p class="yb-title-text-pormpt-small">';
		innerHtml += obj.descr;
		innerHtml += '</p><div class="info" style="position:absolute; bottom:0px;"><span class="yb-title-text-pormpt-small"><span class="price">¥' + obj.discountTotalRentalShow + '</span>/天</span></div></div></a></div></li>';
		return innerHtml;
	}

	function htmlBuyGoods(obj) {
		var innerHtml = '<li data-pid="' + obj.id + '" data-isBorrow="false" class="mui-table-view-cell mui-collapse mui-checkbox mui-left">';
		innerHtml += '<input name="checkbox" type="checkbox" ' + (obj.selected ? "checked" : "") + '>';
		innerHtml += '<div class="mui-slider-right mui-disabled"><a class="mui-btn mui-btn-red">删除</a></div>';
		innerHtml += '<div class="mui-slider-handle">';
		innerHtml += '<a href="item/' + obj.url + '"><img class="yb-mui-media-object-middling mui-pull-left" src="images/product/s300x300/' + obj.icon + '">';
		innerHtml += '<div class="mui-media-body" style="height:90px;position:relative"><span class="yb-title-text-importmant mui-ellipsis-2">';
		innerHtml += obj.name;
		innerHtml += '</span><div style="position:absolute;width:100%;left:0;bottom:0"><span class="info"><span class="price">¥' + obj.unitPriceShow + '</span></span></a>';
		innerHtml += '<span class="mui-numbox mui-pull-right" data-numbox-min="1" data-numbox-max="10">';
		innerHtml += '<button class="mui-btn mui-btn-numbox-minus" type="button">-</button>';
		innerHtml += '<input data-last-value="' + obj.num + '" class="mui-input-numbox" type="number" value="' + obj.num + '" />';
		innerHtml += '<button class="mui-btn mui-btn-numbox-plus" type="button">+</button>';
		innerHtml += '</span></div></div></div></li>';
		return innerHtml;
	};
	var isLogin = false;
	ybAjaxGet("/services/user/getIndexPrivateData", null, function(jsonObj) {
		var r = jsonObj.data;
		if(parseBoolean(r.login)) {
			isLogin = true;
			setEleText('moneyNum', r.money);
			setEleText('beibiNum', r.beibi);
			setEleText('couponNum', r.coupon);
			setEleText('userName', r.name);
			setEleText('userPhone', r.phone);
			if(isNotBlank(r.icon)) {
				getEle('userIcon').src = '../images/headicon/s100x100/' + r.icon + '?r=' + randomString(6);
			}
			setEleText('logButton', '退出登录');
			var myLikeCategory = categoryList("常用分类", r.myLikeCategory);
			if(isNotBlank(myLikeCategory)) {
				getEle('content0').appendChild(myLikeCategory);
			}
			if(r.unReadMsg > 0) {
				setEleText('unReadMsgFlag', r.unReadMsg);
				showEle('tab-newmessage-flag');
				showEle('unReadMsgFlag');
			}
			if(r.unPaidOrder > 0) {
				setEleText('unPaidFlag', r.unPaidOrder);
				showEle('unPaidFlag');
			}
			if(r.unPjCount > 0) {
				setEleText('unPjFlag', r.unPjCount);
				showEle('unPjFlag');
			}
			if(r.unConfirmOrder > 0) {
				setEleText('unConfirmFlag', r.unConfirmOrder);
				showEle('unConfirmFlag');
			}
			setEleText('vipTypeName', r.vipTypeName);
			if(r.vipType == 2) {
				addClass('vipTypeName', 'gold-card-member');
			} else if(r.vipType == 3) {
				addClass('vipTypeName', 'platinum-card-member');
			} else {
				addClass('vipTypeName', 'card-member');
			}
			showEle('userNamePhone');
		} else {
			showEle('cart-nologin-tip');
			showEle('goreglogin');
			hideEle('userNamePhone');
			setEleText('logButton', '登录');
		}
		var hotCategory = categoryList("热门分类", r.hotCategory);
		if(isNotBlank(hotCategory)) {
			getEle('content0').appendChild(hotCategory);
		}
		var sysBroadcast = r.sysBroadcast;
		if(isNotBlank(sysBroadcast)) {
			var broadcastHtml = broadcastList(sysBroadcast);
			broadcastSwiper.stopAutoplay();
			broadcastSwiper.removeAllSlides();
			if(isNotBlank(broadcastHtml)) {
				broadcastSwiper.appendSlide(broadcastHtml);
				broadcastSwiper.startAutoplay();
			}
		}
	});
	getEle('logButton').addEventListener('tap', function() {
		if(isLogin) {
			YBApp.confirm.show('确定要退出登录吗？', function(e) {
				if(e.index == 1) {
					ybAjaxGet("/services/user/logout", null, function(jsonObj) {
						YBApp.toast(true, jsonObj.msg);
						if(jsonObj.success) {
							if(mui.os.plus) {
								plus.statistic.eventTrig("logout", "open");
							}
							setTimeout(function() {
								YBApp.openWindow('/index.html');
							}, 1500);
						}
					});
				}
			});
		} else {
			YBApp.openWindow('login.html');
		}
	});
	//	getEle('accountLi').addEventListener('tap', function() {
	//		if(isLogin) {
	//			YBApp.openWindow("/my/account.html");
	//		} else {
	//			YBApp.openWindow("login.html");
	//		}
	//	});
	mui(".mui-segmented-control").on('tap', '.mui-control-item', function() {
		var loaded = this.getAttribute("data-loaded");
		var type = this.getAttribute("data-type");
		var reqStr = {
			type: type,
		};
		if(parseBoolean(loaded)) {
			return;
		}
		var self = this;
		ybAjaxGet("/services/book/getBookCategoryWithType", reqStr, function(jsonObj) {
			if(jsonObj.success) {
				self.setAttribute("data-loaded", "true");
				var v = categoryList(null, jsonObj.data);
				if(isNotBlank(v)) {
					getEle(self.getAttribute("data-cId")).appendChild(v);
				}
			}
		}, true);

	});

	function categoryList(titleName, list) {
		if(!isNotBlank(list)) {
			return null;
		}
		var innerHtml = [];
		var div = document.createElement('div');
		if(isNotBlank(titleName)) {
			innerHtml.push('<h5 class="mui-content-padded">' + titleName + '</h5>');
		}
		innerHtml.push('<ul class="mui-table-view mui-grid-view">');
		mui.each(list, function(idx, obj) {
//			if(obj.type == 2) {
//				innerHtml.push('<li class="mui-table-view-cell mui-col-xs-4">');
//				innerHtml.push('<a href="/search/category.html?c_type=' + obj.type + '&c_id=' + obj.id + '">');
//				innerHtml.push('<div class="category-title mui-ellipsis-2">' + obj.name + '</div>');
//				innerHtml.push('</a>');
//				innerHtml.push('</li>');
//			} else {
				innerHtml.push('<li class="mui-table-view-cell mui-media mui-col-xs-4">');
				innerHtml.push('<a href="/search/category.html?c_type=' + obj.type + '&c_id=' + obj.id + '">');
				innerHtml.push('<img class="mui-media-object" src="/images/active/category/' + obj.icon + '">');
				innerHtml.push('<div class="mui-media-body category-title mui-ellipsis-2">' + obj.name + '</div>');
				innerHtml.push('</a>');
				innerHtml.push('</li>');
//			}
		});
		innerHtml.push('</ul>');
		div.innerHTML = innerHtml.join('');
		return div;
	};

	function broadcastList(list) {
		if(!isNotBlank(list)) {
			return null;
		}
		var innerHtml = [];
		mui.each(list, function(idx, obj) {
			innerHtml.push('<div class="swiper-slide">');
			innerHtml.push('<a href="' + obj.url + '" class="swiper">');
			innerHtml.push('<div class="broadcast_title_top">');
			if(obj.type == 1) {
				innerHtml.push('<span class="headline">Hot</span>');
			}
			innerHtml.push('<span class="broadcast_title_txt">' + obj.title + '</span>');
			innerHtml.push('</div>');
			innerHtml.push('<p class="broadcast_title_bottom text_ellipsis">' + obj.subtitle + '</p>');
			innerHtml.push('</a>');
			innerHtml.push('</div>');
		});
		return innerHtml.join('');
	};
}());